/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.Marshal
 *  com.locojoy.base.Marshal.OctetsStream
 *  com.locojoy.base.Octets
 *  mkio.Protocol
 */
package gnet.link;

import com.locojoy.base.Marshal.Marshal;
import com.locojoy.base.Marshal.OctetsStream;
import com.locojoy.base.Octets;
import gnet.link.Bind;
import gnet.link.Kick;
import gnet.link.Link;
import gnet.link.Onlines;
import gnet.link.Send;
import gnet.link.UnBind;
import java.util.concurrent.atomic.AtomicReference;
import mkio.Protocol;

public class Role {
    private final int userid;
    private final long roleid;
    private final AtomicReference<Link.Session> linkSession = new AtomicReference();

    public Role(int userid, long roleid) {
        this.userid = userid;
        this.roleid = roleid;
    }

    public long getRoleid() {
        return this.roleid;
    }

    public int getUserid() {
        return this.userid;
    }

    public Link.Session getLinkSession() {
        return this.linkSession.get();
    }

    public boolean isOnline() {
        return null != this.linkSession.get();
    }

    void linkBroken() {
        Link.Session ls = this.linkSession.getAndSet(null);
        if (null != ls) {
            ls.close();
        }
    }

    void linkAttach(Link link, int linksid) {
        this.linkSession.set(link.attach(linksid, this));
    }

    public boolean sendOctets(int ptype, Octets poctets) {
        Link.Session ls = this.linkSession.get();
        if (null != ls) {
            Send p1 = new Send();
            p1.linksids.add(ls.getSid());
            p1.ptype = ptype;
            p1.pdata = poctets;
            Onlines.sendSend(p1, ls.getXio());
            return true;
        }
        return false;
    }

    public boolean send(Protocol p2) {
        Link.Session ls = this.linkSession.get();
        if (null != ls) {
            Send p1 = new Send();
            p1.linksids.add(ls.getSid());
            p1.ptype = p2.getType();
            p1.pdata = new OctetsStream().marshal((Marshal)p2);
            ls.getXio().getCreator().getManager().getCoder().checkSend(p2, p1.pdata.size());
            Onlines.sendSend(p1, ls.getXio());
            return true;
        }
        return false;
    }

    public boolean kick(int error) {
        Link.Session ls = this.linkSession.get();
        if (null != ls) {
            Kick p1 = new Kick();
            p1.linksid = ls.getSid();
            p1.action = 1;
            p1.error = error;
            return p1.send(ls.getXio());
        }
        return false;
    }

    public boolean bind(int pvid) {
        Link.Session ls = this.linkSession.get();
        if (null != ls) {
            Bind p1 = new Bind();
            p1.pvid = pvid;
            p1.linksids.add(ls.getSid());
            return p1.send(ls.getXio());
        }
        return false;
    }

    public boolean unbind(int pvid) {
        Link.Session ls = this.linkSession.get();
        if (null != ls) {
            UnBind p1 = new UnBind();
            p1.pvid = pvid;
            p1.linksids.add(ls.getSid());
            return p1.send(ls.getXio());
        }
        return false;
    }

    public String toString() {
        return "userid=" + this.userid + " roleid=" + this.roleid + this.linkSession.get();
    }
}

